; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_ANZEIGE_SDHC:
	LDS temp,(adr_SD_SDHC_AKTIV)	
	tst temp
	brne SD_INFO_w
	call LCD_MINUS3
	jmp  LCD_MINUS3
;-------------------------------------------------------------------------------
SD_INFO_w:
	jmp TEXT_SDHC
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_SEKTOR_VIEW:
	call LCD_CLEAR
	call SEKTOR_NULL
	call WAIT_200ms
;-------------------------------------------------------------------------------
SD_SEKTOR_VIEW_s:
	call SD_SEKTOR_READ			; read		
;-------------------------------------------------------------------------------
	call LCD_ZEILE1
	call TEXT_SEKTOR
	call ANZEIGE_SEKTOR
;-------------------------------------------------------------------------------
	call LCD_ZEILE2
	LDS temp1,(adr_DATA+0)
	call LCD_HEX_TEMP1
	LDS temp1,(adr_DATA+1)
	call LCD_HEX_TEMP1
	LDS temp1,(adr_DATA+2)
	call LCD_HEX_TEMP1
	LDS temp1,(adr_DATA+3)
	call LCD_HEX_TEMP1
	LDS temp1,(adr_DATA+4)
	call LCD_HEX_TEMP1
	LDS temp1,(adr_DATA+5)
	call LCD_HEX_TEMP1
;-------------------------------------------------------------------------------
	sbis (TASTE_D_PIN),(TASTE_D_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	call SEKTOR_PLUS_EINS
;-------------------------------------------------------------------------------
	sbis (TASTE_C_PIN),(TASTE_C_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	call SEKTOR_MINUS_EINS
;-------------------------------------------------------------------------------
	sbis (TASTE_F_PIN),(TASTE_F_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	ret
;-------------------------------------------------------------------------------
	rjmp SD_SEKTOR_VIEW_s
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_ANZEIGE_INFO1:
	call LCD_ZEILE1
	call TEXT_SD
	call TEXT_INFO
	call LCD_1
	call SD_CID_READ				; REGISTER CID	
	call SD_CSD_READ				; REGISTER CSD	
	call SD_OCR_READ				; REGISTER OCR	
	call LCD_SPACE4
	call SD_ANZEIGE_SDHC
;-------------------------------------------------------------------------------
	call LCD_ZEILE2

;-------------------------------------------------------------------------------
	call LCD_ZEILE3
	LDS temp1,(adr_SD_SEKTOR_MAX0)
	LDS temp2,(adr_SD_SEKTOR_MAX1)
	LDS temp3,(adr_SD_SEKTOR_MAX2)
	LDS temp4,(adr_SD_SEKTOR_MAX3)
	call LCD_ZAHL_TEMP1_2_3_4
	call TEXT_SEKTOREN
;-------------------------------------------------------------------------------
	call LCD_ZEILE4

	LDS temp,(adr_SD_PNM1)			; Produkt NAME PNM
	call LCD_DATA_TEMP
	LDS temp,(adr_SD_PNM2)
	call LCD_DATA_TEMP
	LDS temp,(adr_SD_PNM3)
	call LCD_DATA_TEMP
	LDS temp,(adr_SD_PNM4)
	call LCD_DATA_TEMP
	LDS temp,(adr_SD_PNM5)
	call LCD_DATA_TEMP
	call LCD_SPACE

	LDS temp1,(adr_SD_MDT_L)
	LDS temp2,(adr_SD_MDT_H)
	call LCD_ZAHL4_TEMP1_2
	call LCD_SPACE

	LDS temp1,(adr_SD_PSN0)
	call LCD_HEX_TEMP1
	LDS temp1,(adr_SD_PSN1)
	call LCD_HEX_TEMP1
	LDS temp1,(adr_SD_PSN2)
	call LCD_HEX_TEMP1
	LDS temp1,(adr_SD_PSN3)
	call LCD_HEX_TEMP1

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_ANZEIGE_INFO2:
	call LCD_ZEILE1
	call TEXT_SD
	call TEXT_INFO
	call LCD_2
;-------------------------------------------------------------------------------
	call LCD_ZEILE2
	call TEXT_MAX
	LDS temp1,(adr_SD_SEKTOR_MAX0)
	LDS temp2,(adr_SD_SEKTOR_MAX1)
	LDS temp3,(adr_SD_SEKTOR_MAX2)
	LDS temp4,(adr_SD_SEKTOR_MAX3)
	call LCD_ZAHL_TEMP1_2_3_4
;-------------------------------------------------------------------------------
	call LCD_ZEILE3

;-------------------------------------------------------------------------------
	call LCD_ZEILE4

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_ANZEIGE_INFO3:
	call LCD_ZEILE1
	call TEXT_SD
	call TEXT_INFO
	call LCD_3
;-------------------------------------------------------------------------------
	call LCD_ZEILE2

;-------------------------------------------------------------------------------
	call LCD_ZEILE3

;-------------------------------------------------------------------------------
	call LCD_ZEILE4

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_ANZEIGE_INFO4:
	call LCD_ZEILE1
	call TEXT_SD
	call TEXT_INFO
	call LCD_4
;-------------------------------------------------------------------------------
	call LCD_ZEILE2

;-------------------------------------------------------------------------------
	call LCD_ZEILE3

;-------------------------------------------------------------------------------
	call LCD_ZEILE4

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_ANZEIGE_CID:

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_ANZEIGE_CSD:

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_ANZEIGE_OCR:

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_TEST_READ:
	call SEKTOR_NULL
;-------------------------------------------------------------------------------
SD_TEST_READ_s:
	call ZAHLER_NULL
	call UHR_NULL
;-------------------------------------------------------------------------------
SD_TEST_READ_s1:
	call SD_SEKTOR_READ			; read		
	call SEKTOR_PLUS_EINS		; +1		
;-------------------------------------------------------------------------------
SD_TEST_READ_w:
	call ZAHLER_PLUS_EINS
	LDS temp,(adr_ss)
	tst temp
	breq SD_TEST_READ_s1
;-------------------------------------------------------------------------------
	call LCD_ZEILE1				; Zeile	
	call TEXT_READ
	call TEXT_TEST
;-------------------------------------------------------------------------------
	call LCD_ZEILE2				; Zeile	
	call ANZEIGE_ZAEHLER
	call TEXT_SEC_PRO_SEC
;-------------------------------------------------------------------------------
	sbis (TASTE_F_PIN),(TASTE_F_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	ret
;-------------------------------------------------------------------------------
	rjmp SD_TEST_READ_s
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_TEST_READ_MULTIPLE:
	call SEKTOR_NULL
	call SD_SEKTOR_READ_MULTIPLE_START
;-------------------------------------------------------------------------------
SD_TEST_READ_MULTIPLE_s:
	call ZAHLER_NULL
	call UHR_NULL
;-------------------------------------------------------------------------------
SD_TEST_READ_MULTIPLE_s1:
	call SD_SEKTOR_READ_MULTIPLE_DATA	; read		
	call ZAHLER_PLUS_EINS
	call SEKTOR_PLUS_EINS				; +1		
;-------------------------------------------------------------------------------
	LDS temp,(adr_ss)
	tst temp
	breq SD_TEST_READ_MULTIPLE_s1
;-------------------------------------------------------------------------------
	call LCD_ZEILE1				; Zeile	
	call TEXT_READ
	call TEXT_MULTIPLE
	call LCD_ZEILE2				; Zeile	
;-------------------------------------------------------------------------------
	call ANZEIGE_ZAEHLER
	call TEXT_SEC_PRO_SEC
;-------------------------------------------------------------------------------
	sbis (TASTE_F_PIN),(TASTE_F_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	rjmp SD_SEKTOR_READ_MULTIPLE_STOP			; STOP						
;-------------------------------------------------------------------------------
	rjmp SD_TEST_READ_MULTIPLE_s
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_TEST_WRITE:
 	call ZUFALLSZAHL_TEMP		; Kontrollbyte
	call SEKTOR_NULL
	call DATA_CLEAR
	call ZAHLER_NULL
	call UHR_NULL
;-------------------------------------------------------------------------------
SD_TEST_WRITE_s:
	STS(adr_DATA+0),SEKTOR3		; DATA			
	STS(adr_DATA+1),SEKTOR2
	STS(adr_DATA+2),SEKTOR1
	STS(adr_DATA+3),SEKTOR0
	LDS temp,(adr_ZUFALLSZAHL)	; Kontrollbyte	
	STS(adr_DATA+4),temp
	call ZAHLER_PLUS_EINS
	call SD_SEKTOR_WRITE		; write	
	call SEKTOR_PLUS_EINS		; +1	
;-------------------------------------------------------------------------------
	LDS temp,(adr_ss)
	tst temp
	breq SD_TEST_WRITE_s
;-------------------------------------------------------------------------------
	call LCD_ZEILE1				; Zeile	
	call TEXT_WRITE
	call TEXT_TEST
;-------------------------------------------------------------------------------
	call LCD_ZEILE2				; Zeile	
	call ANZEIGE_ZAEHLER
	call TEXT_SEC_PRO_SEC
	call LCD_SPACE
	LDS temp1,(adr_ZUFALLSZAHL)	; Kontrollbyte	
	call LCD_HEX_TEMP1
;-------------------------------------------------------------------------------
	sbis (TASTE_F_PIN),(TASTE_F_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	ret
;-------------------------------------------------------------------------------
	call ZAHLER_NULL
	call UHR_NULL
	rjmp SD_TEST_WRITE_s
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_TEST_WRITE_MULTIPLE:
	call ZUFALLSZAHL_TEMP		; Kontrollbyte
	call SEKTOR_NULL
	call DATA_CLEAR
	call ZAHLER_NULL
	call UHR_NULL
	call SD_SEKTOR_WRITE_MULTIPLE_START	; START !!!
;-------------------------------------------------------------------------------
SD_TEST_WRITE_MULTIPLE_s:
	STS(adr_DATA+0),SEKTOR3				; DATA			
	STS(adr_DATA+1),SEKTOR2
	STS(adr_DATA+2),SEKTOR1
	STS(adr_DATA+3),SEKTOR0
	LDS temp,(adr_ZUFALLSZAHL)			; Kontrollbyte	
	STS(adr_DATA+4),temp
	call SD_SEKTOR_WRITE_MULTIPLE_DATA	; DATA !!!
	call ZAHLER_PLUS_EINS
	call SEKTOR_PLUS_EINS				; +1	
;-------------------------------------------------------------------------------
	LDS temp,(adr_ss)
	tst temp
	breq SD_TEST_WRITE_MULTIPLE_s
;-------------------------------------------------------------------------------
	call LCD_ZEILE1				; Zeile	
	call TEXT_WRITE
	call TEXT_MULTIPLE
;-------------------------------------------------------------------------------
	call LCD_ZEILE2				; Zeile	
	call ANZEIGE_ZAEHLER
	call TEXT_SEC_PRO_SEC
	call LCD_SPACE
	LDS temp1,(adr_ZUFALLSZAHL)	; Kontrollbyte	
	call LCD_HEX_TEMP1
;-------------------------------------------------------------------------------
	sbis (TASTE_F_PIN),(TASTE_F_PIN_NR)	; springe, wenn BIT(PIN) HIGH
	rjmp SD_SEKTOR_WRITE_MULTIPLE_STOP	; STOP !!!
;-------------------------------------------------------------------------------
	call ZAHLER_NULL
	call UHR_NULL
	rjmp SD_TEST_WRITE_MULTIPLE_s
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_TEST_WRITE_READ:
 	call ZUFALLSZAHL_TEMP		; Kontrollbyte
	call SEKTOR_NULL
	call DATA_CLEAR
	call UHR_NULL
;-------------------------------------------------------------------------------
SD_TEST_WRITE_READ_s:
	STS(adr_DATA+0),SEKTOR3		; DATA			
	STS(adr_DATA+1),SEKTOR2
	STS(adr_DATA+2),SEKTOR1
	STS(adr_DATA+3),SEKTOR0
	LDS temp,(adr_ZUFALLSZAHL)	; Kontrollbyte	
	STS(adr_DATA+4),temp
	call SD_SEKTOR_WRITE		; write	
;-------------------------------------------------------------------------------
	call SD_SEKTOR_READ			; read		
	LDS temp,(adr_DATA+0)
	cp temp,SEKTOR3				; Vegleich	
	brne SD_TEST_WRITE_ERROR
	LDS temp,(adr_DATA+1)
	cp temp,SEKTOR2				; Vegleich	
	brne SD_TEST_WRITE_ERROR
	LDS temp,(adr_DATA+2)
	cp temp,SEKTOR1				; Vegleich	
	brne SD_TEST_WRITE_ERROR
	LDS temp,(adr_DATA+3)
	cp temp,SEKTOR0				; Vegleich	
	brne SD_TEST_WRITE_ERROR
	LDS temp,(adr_DATA+4)
	LDS temp1,(adr_ZUFALLSZAHL)	; Kontrollbyte
	cp temp,temp1				; Vegleich	
	brne SD_TEST_WRITE_ERROR
	rjmp SD_TEST_WRITE_READ_w
;-------------------------------------------------------------------------------
SD_TEST_WRITE_ERROR:
	call LCD_CLEAR
	call TEXT_ERROR
	call LCD_ZEILE3
	call TEXT_SEKTOR
	call ANZEIGE_SEKTOR
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an	
	call WAIT_50ms
;-------------------------------------------------------------------------------
SD_TEST_WRITE_READ_w:
	call SEKTOR_PLUS_EINS		; +1	
	call SD_SEKTOR_OVERLOW_C			; komplett ?
	brcs SD_TEST_WRITE_READ_EXIT
	tst SEKTOR0
	brne SD_TEST_WRITE_READ_s
;-------------------------------------------------------------------------------
	call LCD_ZEILE1				; Zeile	
	call TEXT_SD
	call TEXT_WRITE
	call TEXT_READ
	call TEXT_TEST
	call LCD_ZEILE2				; Zeile	
	call ANZEIGE_SEKTOR
	call LCD_ZEILE3				; Zeile	
	call SD_PROZENT
	call SD_MB
	call LCD_ZEILE4				; Zeile	
	call ANZEIGE_ZEIT
	call LCD_SPACE
	LDS temp1,(adr_ZUFALLSZAHL)	; Kontrollbyte	
	call LCD_HEX_TEMP1
;-------------------------------------------------------------------------------
	call TASTEN_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	brne SD_TEST_WRITE_READ_EXIT
	rjmp SD_TEST_WRITE_READ_s	
;-------------------------------------------------------------------------------
SD_TEST_WRITE_READ_EXIT:

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_FORMATIERUNG_LL:
	call SEKTOR_NULL
	call UHR_NULL
	call DATA_CLEAR
	call SD_SEKTOR_WRITE_MULTIPLE_START	; START !!!
;-------------------------------------------------------------------------------
SD_FORMATIERUNG_s:
	call SD_SEKTOR_WRITE_MULTIPLE_DATA	; DATA !!!	
	LDS temp1,(adr_ss)
	LDS temp2,(adr_ss_OLD)
	cp temp1,temp2
	breq SD_FORMATIERUNG_w 
	STS(adr_ss_OLD),temp1
;-------------------------------------------------------------------------------
	call LCD_ZEILE1
	call TEXT_SD
	call TEXT_FORMAT
	call LCD_ZEILE3
	call SD_PROZENT
	call SD_MB
	call LCD_ZEILE4
	call ANZEIGE_ZEIT
	call TASTEN_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	brne SD_FORMATIERUNG_EXIT
;-------------------------------------------------------------------------------
SD_FORMATIERUNG_w:
	call SEKTOR_PLUS_EINS		; +1	
	rcall SD_SEKTOR_OVERLOW_C
	brcc SD_FORMATIERUNG_s	; Schleife	
;-------------------------------------------------------------------------------
SD_FORMATIERUNG_EXIT:
	call SD_SEKTOR_WRITE_MULTIPLE_STOP	; STOP !!!
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Anzeige in %																	
SD_PROZENT:
	mov temp1,SEKTOR0				; Divident	
	mov temp2,SEKTOR1
	mov temp3,SEKTOR2
	mov temp4,SEKTOR3

	LDS temp5,(adr_SD_SEKTOR_MAX0)	; Divisor	
	LDS temp6,(adr_SD_SEKTOR_MAX1)
	LDS temp7,(adr_SD_SEKTOR_MAX2)
	LDS temp8,(adr_SD_SEKTOR_MAX3)
; ------------------------------------------------------------------------------
; Divisor auf 16 Bit krzen														
SD_PROZENT_s2:	
	LSR temp4				; Divident :2		
	ROR temp3
	ROR temp2
	ROR temp1
	LSR temp8				; Divisor :2		
	ROR temp7
	ROR temp6
	ROR temp5
	tst temp7				; noch 24 Bit?		
	brne SD_PROZENT_s2
	tst temp8				; noch 32 Bit?		
	brne SD_PROZENT_s2
; ------------------------------------------------------------------------------
	ldi temp3,LOW (100)
	ldi temp4,high(100)
	call MULTIPLIKATION_16_16_32	; Divident x 100
	call DIVISION_32_16				; Division		
	call LCD_ZAHL_TEMP1_2_3_4		; Ergebnis		
	call LCD_PROZENT
	call LCD_SPACE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_MB:
	mov temp1,SEKTOR0				
	mov temp2,SEKTOR1
	mov temp3,SEKTOR2
	mov temp4,SEKTOR3
	call TEMP1_2_3_4_MAL_512		; x 512
	call TEMP1_2_3_4_DURCH_1000
	call TEMP1_2_3_4_DURCH_1000
	call LCD_ZAHL_TEMP1_2_3_4		; Ergebnis		
	call TEXT_MB
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
